/*

 Copyright 2013, SIANI - ULPGC
 Jose Juan Hernandez Cabrera
 Jose Evora Gomez
 Johan Sebastian Cortes Montenegro

 This File is Part of JavaFMI Project

 JavaFMI Project is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 JavaFMI Project is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with JavaFMI Library.  If not, see <http://www.gnu.org/licenses/>.

 */
package org.javafmi;

public class Status {

    public static final Status OK = new Status("ok");
    public static final Status WARNING = new Status("warning");
    public static final Status DISCARD = new Status("discard");
    public static final Status ERROR = new Status("error");
    public static final Status FATAL = new Status("fatal");
    public static final Status PENDING = new Status("pending");
    private static Status[] status = {OK, WARNING, DISCARD, ERROR, FATAL, PENDING};
    private String value;

    private Status(String value) {
        this.value = value;
    }

    public String getValue() {
        return value;
    }

    public static Status getStatus(Integer code) {
        return status[code];
    }

    @Override
    public String toString() {
        return value;
    }
}
